Subject: Re: Reducing git size by building libgit.so

From: SZEDER Gábor <[email-masked]>
Date: Wed, 12 Jun 2019 12:25:37 +0200

On Wed, Jun 12, 2019 at 11:41:10AM +0200, Ævar Arnfjörð Bjarmason wrote:
> On Tue, Jun 11 2019, Elmar Pruesse wrote:
> > The total compiled size of libexec/git-core is currently somewhere
> > around 30 MB. This is largely due to a number of binaries linking
> > statically against libgit.a. For some folks, every byte counts.

I wonder whether those folks actually need such non-builtin git
binaries like 'git-shell' or 'git-daemon' in the first place.

> We still have some stand-alone binaries, but IIRC there's under 5 of
> those with INSTALL_SYMLINKS. We could probably also just make those
> built-ins to get the rest of the size benefits.
> 
> I.e. we'd just have one git binary, everything else symlinking to that,
> and we'd route to the right program by inspecting argv, which we mostly
> do already.

Let's not forget that commands like 'git-daemon' and 'git-shell' are
better left as stand-alone programs.